/* prime.pl */
/* Primzahlen kleiner X suchen */

prime(X, L) :- prime( [ 2, 3, 5 ], L, 5, X ), !, print_list( L ), true.

prime( L, L, MAX, MAX ).
prime( L, L2, X, MAX ) :- Y is X + 1, 
		( is_prime( L, Y ),
		  append( L, [ Y ], L1 ),
		  prime( L1, L2, Y, MAX ) ;
		  prime( L, L2, Y, MAX)) .

is_prime( [ H | T ], X ) :-
	Y is X mod H,
	Y =\= 0,
	is_prime( T, X ).
is_prime( [], _ ).

print_list( [] ).
print_list( [ X ] ) :- write( X ).
print_list( [ H | T ] ) :- write( H ), write(','), print_list( T ).

/* append(A, B, C) == [A,B] is C */
append( [], Y, Y ).
append( [A | B ], C, [ A | D ] ) :- append( B, C, D ).
