
mann(richard).
mann(martin).
mann(christoph).
mann(josef).
mann(andreas).
mann(theo).

frau(lisbeth).
frau(selma).
frau(christa).
frau(hildegard).
frau(gudula).
frau(anna).
frau(hella).

vater(christoph, richard).
vater(christa, martin).
vater(andreas, christoph).
vater(gudula, josef).
vater(anna, andreas).
vater(hella, andreas).
vater(theo, andreas).

mutter(christoph, lisbeth).
mutter(christa, selma).
mutter(andreas, christa).
mutter(gudula, hildegard).
mutter(anna, gudula).
mutter(hella, gudula).
mutter(theo, gudula).

oma( X, Y ) :- mutter( X, Z ), mutter( Z, Y ).
oma( X, Y ) :- vater( X, Z ), mutter( Z, Y ).

opa( X, Y ) :- mutter( X, Z ), vater( Z, Y ).
opa( X, Y ) :- vater( X, Z ), vater( Z, Y ).

schwester( X, Y ) :- frau( Y ), vater( X, Z ), vater( Y, Z ).
schwester( X, Y ) :- frau( Y ), mutter( X, Z ), mutter( Y, Z ).

bruder( X, Y ) :- mann( Y ), vater( X, Z ), vater( Y, Z ).
bruder( X, Y ) :- mann( Y ), mutter( X, Z ), mutter( Y, Z ).

schwager( X, Y ) :- mann( Y ),
		( oma( Z, X ) ; opa( Z, X )) ,
		( oma( Z, Y ) ; opa( Z, Y )).
